Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_lim3
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_lim3	(revision 3933)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_lim3	(revision 3934)
@@ -62,4 +62,5 @@
    telast      =9600.0     !  timescale for elastic waves, SB, 720.0
    alphaevp    =   1.0     !  coefficient for the solution of internal ice stresses
+   hminrhg     =   0.05     !  ice thickness (m) below which ice velocity equal ocean velocity
 /
 !-----------------------------------------------------------------------
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/ice.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/ice.F90	(revision 3933)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/ice.F90	(revision 3934)
@@ -187,4 +187,5 @@
    REAL(wp), PUBLIC ::   alphaevp = 1._wp      !: coeficient of the internal stresses !SB
    REAL(wp), PUBLIC ::   unit_fac = 1.e+09_wp  !: conversion factor for ice / snow enthalpy
+   REAL(wp), PUBLIC ::   hminrhg = 0.05_wp     !: clem : ice thickness (in m) below which ice velocity is set to ocean velocity
 
    !                                              !!** ice-salinity namelist (namicesal) **
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limdyn.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limdyn.F90	(revision 3933)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limdyn.F90	(revision 3934)
@@ -276,5 +276,5 @@
          &                dm, nbiter, nbitdr, om, resl, cw, angvg, pstar,   &
          &                c_rhg, etamn, creepl, ecc, ahi0, &
-         &                nevp, telast, alphaevp
+         &                nevp, telast, alphaevp, hminrhg
       !!-------------------------------------------------------------------
 
@@ -304,4 +304,5 @@
          WRITE(numout,*) '   timescale for elastic waves                      telast = ', telast
          WRITE(numout,*) '   coefficient for the solution of int. stresses  alphaevp = ', alphaevp
+         WRITE(numout,*) '   min ice thickness for rheology calculations     hminrhg = ', hminrhg
       ENDIF
       !
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limrhg.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limrhg.F90	(revision 3933)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/MY_SRC/limrhg.F90	(revision 3934)
@@ -36,4 +36,8 @@
 #endif
    USE lib_fortran      ! to use key_nosignedzero
+
+#if defined key_bdy
+   USE bdyice_lim
+#endif
 
    IMPLICIT NONE
@@ -571,4 +575,9 @@
 
          ENDIF
+         
+!#if defined key_bdy
+!         ! clem: change u_ice and v_ice at the boundary for each iteration
+!         CALL bdy_ice_lim_dyn()
+!#endif         
 
          IF(ln_ctl) THEN
@@ -582,15 +591,14 @@
          ENDIF
 
-         !                                                   ! ==================== !
+         !                                                ! ==================== !
       END DO                                              !  end loop over jter  !
       !                                                   ! ==================== !
-
       !
       !------------------------------------------------------------------------------!
       ! 4) Prevent ice velocities when the ice is thin
       !------------------------------------------------------------------------------!
-      !clem : change zdummy from 5.e-2 to 1.e-2
-      !
-      ! If the ice thickness is below 1cm then ice velocity should equal the
+      !clem : add hminrhg in the namelist
+      !
+      ! If the ice thickness is below hminrhg (5cm) then ice velocity should equal the
       ! ocean velocity, 
       ! This prevents high velocity when ice is thin
@@ -601,5 +609,5 @@
             zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
                u_ice(ji,jj) = u_oce(ji,jj)
                v_ice(ji,jj) = v_oce(ji,jj)
@@ -610,4 +618,9 @@
       CALL lbc_lnk( u_ice(:,:), 'U', -1. ) 
       CALL lbc_lnk( v_ice(:,:), 'V', -1. ) 
+
+      ! clem: change u_ice and v_ice at the boundary
+#if defined key_bdy
+      CALL bdy_ice_lim_dyn()
+#endif         
 
       DO jj = k_j1+1, k_jpj-1 
@@ -615,5 +628,5 @@
             zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
                v_ice1(ji,jj)  = 0.5*( (v_ice(ji,jj)+v_ice(ji,jj-1))*e1t(ji+1,jj)   &
                   &                 +(v_ice(ji+1,jj)+v_ice(ji+1,jj-1))*e1t(ji,jj)) &
@@ -640,5 +653,5 @@
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
 
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
 
                zdd(ji,jj) = ( e2u(ji,jj)*u_ice(ji,jj)                      &